#include "ModuleSwitch.h"
#include <iostream>

namespace mdd{
    ModuleSwitch::ModuleSwitch(){
        json default_val;
        default_val["value"] = 42;
        auto veri = [](const json& val){
            if(val.find("value")==val.end())
                return false;
            return true;
        };
        addInput("Switch", default_val, veri);
        addInput("Value", default_val, veri);
        addInput("Value", default_val, veri);
        addOutput("Value", default_val);
        setType("Switch");
    }
    bool ModuleSwitch::update(){
        std::cout << "SWITCH"<<"\n" << getInputValue(0).dump()<<"\n";
        int index = getInputValue(0)["value"].get<int>();
        if(index > getInputs().size() - 2){
            index = getInputs().size() - 2;
        }

        json ret = getInputValue(index + 1)["value"];

        if (ret.dump() != getOutput(0)->getValue()["value"].dump()) {
            setOutputValue(0)["value"] = ret ;
            return true;
        }
        else{
            return false;
        }
    }
}