#ifndef MDD_IPROCESSOR_H
#define MDD_IPROCESSOR_H

#include "IModule.h"
#include <vector>

namespace mdd
{

    class IProcessor: public  IModule{
    public:
        virtual int  addModule(std::shared_ptr<IModule> module) = 0;
        virtual std::vector<std::string> getModules() = 0;
        virtual std::shared_ptr<IModule> getModule(int handle) = 0;
    };
}

#endif //MDD_IPROCESSOR_H
